\chapter{Conclusion}

\section{Results}
In conclusion, no relevant difference between the \verb+DB18p1+ and the \verb+DB18p4+ could be proven. Small deviations across the different measurements are always visible. It is however,  not save to assume that these measurements are due to hardware changes within the \verb+DB18+ production rounds (i.e. between the \verb+DB18p1+ and the \verb+DB18p1+). The hardware is very closely related if not the exact same.

\vspace{5mm}
The Raspberry Pi \verb+4B+ shows tendentially a better performance in lane following. However,  the comparison between the Raspberry Pi \verb+4B+ and the Raspberry Pi \verb~3B+~ is not completely representative as the version of HypriotOS is not the same (use of the \verb+--experimental+ tag). 

\vspace{5mm}
It is nonetheless possible that small deviations between the different production round exist. But these are minimal with respect to the influence of external disturbances like badly focused or calibrated camera, low battery voltage or strong light from the side.

\vspace{5mm}
Having conducted multiple measurements for different bots of type \verb+DB18p1+ and \verb+DB18p4+ a general baseline has been established. These measurements are provided in the repository of the API. However,  this baseline might have to be adjusted respectiveley adjusted in case that the score calculation has been adjusted. 

\section{Discussion}
\subsection{Reproducibility and Stability} \label{sec:repro_stab} 
The measurements from figure \ref{fig:meas_stab} originate from a measurements run on the same bot within several minutes.It is visible that the measurements lie in close proximity. Comparing the corresponding graphs it is visible that the measurement of the left score measured more detected lane segments. Thus, the lower score may definitely have an external source.

\vspace{5mm}
Especially the lane following score depends highly on environmental constraints. Thus, by changing the location some deviations occurred. The detected lane segments correlate directly with the the illuminated area, light falling in horizontally as well as the surrounding of the map. There is a trade off between a exact definition and the ease of use. If one agreed to reduce the ease of use, one could define a range of illumination (in Lux,  $\frac{\text{Lumen}}{\text{Area}}$) for the complete map which then would have to be measured.

\begin{figure}[hbt!]
    \centering
    \includegraphics[width=.95\textwidth, trim={25 100 25 10}, clip]{img/discussion/measurement_stability.png}
    \caption{Measurements stability}
    \label{fig:meas_stab}
\end{figure}


\subsection{Limitations}
The current hardware benchmark doesn't directly cover the following scenarios:
\begin{itemize}
    \item Broken PiHut or motor, wrongly connected motors
    \item Broken or wrongly connected camera
    \item Bad calibration
    \item Network related issues
\end{itemize}
The tools used in this thesis are not able to perform an exhaustive hardware check, this could however,  be done with the hardware check developed at Duckietown \cite{apetrov}. It doesn't detect the concrete errors in a specific hardware which performs below expectations. However,  the respective scores in conjunction with the graphs give a hint in the direction where further investigation is needed.